exercise_04_18: exercise_04_18.o | .gitignore
	g++ $^ -o $@ 

exercise_04_18.ii: exercise_04_18.cpp
	g++ -E $^ -o $@

exercise_04_18.s: exercise_04_18.ii
	g++ -S $^ -o $@

exercise_04_18.o: exercise_04_18.s
	g++ -c $^ -o $@

.gitignore:
	echo "exercise_04_18" > $@

clean:
	rm -rf *.ii *.s *.o *.out exercise_04_18 .gitignore debug

test: exercise_04_18 
	./exercise_04_18 > test.out
	diff test.out test.expected > /dev/null 2>&1 && echo PASSED || echo FAILED

.PRECIOUS: exercise_04_18.ii exercise_04_18.s
.SECONDARY: exercise_04_18.ii exercise_04_18.s

dbg: debug/exercise_04_18 

debug/exercise_04_18: debug/exercise_04_18.o | .gitignore
	g++ -Wall -Wextra -Werror -g3 $^ -o $@

debug/exercise_04_18.o: debug/exercise_04_18.s
	g++ -c -Wall -Wextra -Werror -g3 $^ -o $@

debug/exercise_04_18.s: debug/exercise_04_18.ii
	g++ -S -Wall -Wextra -Werror -g3 $^ -o $@

debug/exercise_04_18.ii: exercise_04_18.cpp | debug
	g++ -E -Wall -Wextra -Werror -g3 $^ -o $@

debug:
	mkdir -p debug

